const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const user_gamification = sequelize.define(
    'user_gamification',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

points_total: {
        type: DataTypes.INTEGER,
      
      

      },

streak_days: {
        type: DataTypes.INTEGER,
      
      

      },

last_activity_at: {
        type: DataTypes.DATE,
      
      

      },

daily_activity_json: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  user_gamification.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.user_gamification.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.user_gamification.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.user_gamification.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return user_gamification;
};


